'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _crossSpawnPromise = require('cross-spawn-promise');

var _crossSpawnPromise2 = _interopRequireDefault(_crossSpawnPromise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function parseOptions(opts) {
  var availableOptions = ['type', 'loader', 'connection', 'mutation'];

  // Check if any commands was provided
  var anyCommandsProvided = Object.keys(opts).some(function (option) {
    return availableOptions.indexOf(option) !== -1;
  });

  var options = opts;

  // If not, use the default options
  if (!anyCommandsProvided) {
    options = _extends({
      type: true,
      loader: true,
      connection: true,
      mutation: true
    }, options);
  }

  var _options = options,
      type = _options.type,
      loader = _options.loader,
      connection = _options.connection,
      mutation = _options.mutation,
      schema = _options.schema;


  return {
    type: type || false,
    loader: loader || false,
    connection: connection || false,
    mutation: mutation || false,
    schema: schema || false
  };
}

function generate(name, options) {
  var _this = this;

  // Parse all arguments
  var parsedOptions = parseOptions(options);
  // Get only the chose arguments
  var chosenOptions = Object.keys(parsedOptions).filter(function (opt) {
    return !!parsedOptions[opt];
  });

  // Check if schema argument has been passed
  var schemaIndex = chosenOptions.indexOf('schema');
  chosenOptions.forEach(function () {
    var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(option) {
      var payload;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              payload = ['graphql:' + option, name];

              // If argument schema exists

              if (schemaIndex !== -1) {
                // Remove the next running option because the schema must be used along with this command
                chosenOptions.splice(schemaIndex, 1);

                // Push schema to the arguments to send to yeoman
                payload.push(parsedOptions.schema);
              }

              _context.next = 4;
              return (0, _crossSpawnPromise2.default)('yo', payload, {
                shell: true,
                stdio: 'inherit'
              });

            case 4:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }());
}

exports.default = generate;