'use strict';

require('babel-polyfill');

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _package = require('../package.json');

var _package2 = _interopRequireDefault(_package);

var _commands = require('./commands');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

_commander2.default.version(_package2.default.version);

_commander2.default.command('init <project>').alias('i').description('Create a new GraphQL project').action(function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(project) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _utils.verifyYeoman)();

          case 2:

            (0, _commands.init)(project);

          case 3:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}());

_commander2.default.command('generate <name>').alias('g').option('-t, --type', 'Generate a new Type').option('-l, --loader', 'Generate a new Loader').option('-c, --connection', 'Generate a new Connection').option('-m, --mutation', 'Generate a new Mutation').option('--schema <modelPath>', 'Generate from a Mongoose Schema').description('Generate a new file (Type, Loader, Mutation, etc)').action(function () {
  var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(name, options) {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _utils.verifyYeoman)();

          case 2:

            (0, _commands.generate)(name, options);

          case 3:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function (_x2, _x3) {
    return _ref2.apply(this, arguments);
  };
}());

_commander2.default.parse(process.argv);

if (process.argv.length <= 2) {
  _commander2.default.help();
}