'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.verifyYeoman = undefined;

var _shelljs = require('shelljs');

var _shelljs2 = _interopRequireDefault(_shelljs);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _ora = require('ora');

var _ora2 = _interopRequireDefault(_ora);

var _crossSpawnPromise = require('cross-spawn-promise');

var _crossSpawnPromise2 = _interopRequireDefault(_crossSpawnPromise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var tic = _chalk2.default.green('✓');
var tac = _chalk2.default.red('✗');

var installYeoman = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
    var spinner, command, args, options;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            spinner = (0, _ora2.default)('Installing Yeoman...');


            spinner.start();

            command = 'npm';
            args = ['install', '-g', 'yo'];
            options = {
              shell: true,
              stdio: false
            };
            _context.prev = 5;
            _context.next = 8;
            return (0, _crossSpawnPromise2.default)(command, args, options);

          case 8:

            spinner.stop();

            console.log(tic + ' Yeoman installed!');
            _context.next = 16;
            break;

          case 12:
            _context.prev = 12;
            _context.t0 = _context['catch'](5);

            spinner.stop();

            console.error(tac + ' There was an error while trying to install Yeoman:', _context.t0);

          case 16:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[5, 12]]);
  }));

  return function installYeoman() {
    return _ref.apply(this, arguments);
  };
}();

var verifyYeoman = exports.verifyYeoman = function () {
  var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (_shelljs2.default.which('yo')) {
              _context2.next = 4;
              break;
            }

            console.error(tac + ' GraphQL CLI requires Yeoman to be installed.');

            _context2.next = 4;
            return installYeoman();

          case 4:
            return _context2.abrupt('return', true);

          case 5:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function verifyYeoman() {
    return _ref2.apply(this, arguments);
  };
}();